package com.mortals.xhx.module.device.web;

import cn.hutool.core.codec.Base64;
import com.mortals.framework.exception.AppException;
import com.mortals.framework.model.Context;
import com.mortals.framework.model.OrderCol;
import com.mortals.framework.web.BaseCRUDJsonBodyMappingController;
import com.mortals.xhx.common.code.LogTypeEnum;
import com.mortals.xhx.module.device.model.DeviceLogEntity;
import com.mortals.xhx.module.device.service.DeviceLogService;
import org.springframework.util.ObjectUtils;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.Arrays;
import java.util.Map;

/**
 * 设备日志
 *
 * @author zxfei
 * @date 2022-06-27
 */
@RestController
@RequestMapping("device/log")
public class DeviceLogController extends BaseCRUDJsonBodyMappingController<DeviceLogService, DeviceLogEntity, Long> {


    public DeviceLogController() {
        super.setModuleDesc("设备日志");
    }

    @Override
    protected void init(Map<String, Object> model, Context context) {
        this.addDict(model, "logType", LogTypeEnum.getEnumMap());
        super.init(model, context);
    }

    @Override
    protected void doListBefore(DeviceLogEntity query, Map<String, Object> model, Context context) throws AppException {
        if (ObjectUtils.isEmpty(query.getOrderColList())) {
            query.setOrderColList(Arrays.asList(new OrderCol("createTime", OrderCol.DESCENDING)));
        }
        super.doListBefore(query, model, context);
    }


    @Override
    protected int viewAfter(Long id, Map<String, Object> model, DeviceLogEntity entity, Context context) throws AppException {
        entity.setContent(Base64.decodeStr(entity.getContent()));
        return super.viewAfter(id, model, entity, context);
    }

    public static void main(String[] args) {
        String en="好的";

        System.out.println(Base64.decodeStr(en));
    }
}